#include "./philo.h"
#include "struct.h"
#include <stdbool.h>
#include <stddef.h>

int	philos_init(t_data *data)
{
	size_t		i;

	i = 0;
	while (i < data->nb_philos)
	{
		data->philos[i] = philo_init(data);
		if (data->philos[i] == NULL)
		{
			while (i > 0)
			{
				philo_destroyer(data->philos[i]);
				i--;
			}
			return (1);
		}
		i++;
	}
	return (0);
}

void	philos_destroyer(t_data *data)
{
	size_t	i;

	i = 0;
	while (i < data->nb_philos)
	{
		philo_destroyer(data->philos[i]);
		i++;
	}
	free(data->philos);
}
